SystemOrganization addCategory: #LoadOrderTests!

!WriteStream methodsFor: '*loadordertests' stamp: 'jgf 2/6/2009 12:01'!
show: aString

	^self nextPutAll: aString.
	! !

Object subclass: #SeasideLoadOrderTests
	instanceVariableNames: 'userName password seaside29 komHttpServer baseTests baseUndeclared doTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoadOrderTests'!

!SeasideLoadOrderTests commentStamp: 'jgf 2/6/2009 12:08' prior: 0!
SeasideLoadOrderTests provides a single class that loads the packages described on the LoadOrder Wiki (http://code.google.com/p/seaside/wiki/LoadOrder), and shows the errors and undefined along the way.!

!SeasideLoadOrderTests class methodsFor: 'initialization' stamp: 'jgf 2/6/2009 11:20'!
initialize

	(UIManager default confirm: 'Load Seaside 2.9?') ifTrue: [
		self new doLoad.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:11'!
adminToolsPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-OmniBrowserTools-MAD.23.mcz';
		add: seaside29 -> 'Seaside-Squeak-OmniBrowserTools-jgf.1.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:16'!
basicPackages

	^OrderedCollection new
		"Platform"
		add: (Array 
			with: seaside29 -> 'Seaside-Platform-lr.54.mcz'
			with: seaside29 -> 'Seaside-Squeak-Platform-pmm.66.mcz'
			with: seaside29 -> 'Seaside-Tests-Platform-lr.61.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Platform-lr.17.mcz');
		"Core"
		add: (Array 
			with: seaside29 -> 'Seaside-Core-lr.495.mcz'
			with: seaside29 -> 'Seaside-Tests-Core-lr.117.mcz'
			with: seaside29 -> 'Seaside-Squeak-Core-jf.76.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Core-pmm.21.mcz');
		"Canvas"
		add: (Array 
			with: seaside29 -> 'Seaside-Canvas-jf.53.mcz'
			with: seaside29 -> 'Seaside-Tests-Canvas-jf.23.mcz');
		"Continuation"
		add: (Array 
			with: seaside29 -> 'Seaside-Squeak-Continuation-jf.19.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Continuation-lr.7.mcz');
		"Session"
		add: (Array 
			with: seaside29 -> 'Seaside-Session-lr.102.mcz'
			with: seaside29 -> 'Seaside-Tests-Session-jf.22.mcz');
		"Component"
		add: (Array 
			with: seaside29 -> 'Seaside-Component-jf.56.mcz'
			with: seaside29 -> 'Seaside-Tests-Component-jf.21.mcz');
		"RenderLoop"
		add: (Array 
			with: seaside29 -> 'Seaside-RenderLoop-jf.58.mcz'
			with: seaside29 -> 'Seaside-Tests-RenderLoop-jf.7.mcz');
		"Environment"
		add: (Array 
			with: seaside29 -> 'Seaside-Environment-lr.48.mcz'
			with: seaside29 -> 'Seaside-Tests-Environment-jf.13.mcz');
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:14'!
comanchePackages

	^OrderedCollection new
		add: komHttpServer	-> 'DynamicBindings-gc.7.mcz';
		add: komHttpServer	-> 'KomServices-gc.19.mcz';
		add: komHttpServer	-> 'KomHttpServer-rjl.43.mcz';
		add: seaside29		-> 'Seaside-Adaptors-Comanche-lr.35.mcz';
		add: seaside29		-> 'Seaside-Tests-Adaptors-Comanche-pmm.8.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'utility' stamp: 'jgf 2/6/2009 09:08'!
condenceChanges
"
	SeasideLoadOrderTests new condenseChanges.
"
	Smalltalk condenseChanges.
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 12:11'!
doLoad

	self groups do: [:aList | 
		self 
			loadPackages: aList;
			doTests;
			yourself.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 16:12'!
doTests

	| suite result |
	doTests ifFalse: [^self].
	suite := TestCase suite.
	baseTests do: [:oldTest | 
		| duplicate |
		duplicate := suite tests detect: [:newTest | newTest class == oldTest class and: [newTest selector == oldTest selector]].
		suite tests remove: duplicate.
	].
	result := suite run.
	Transcript cr; tab; show: result printString.
	result defects do: [:each | 
		Transcript cr; tab; tab; show: each printString.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:09'!
emailPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-Email-lr.10.mcz';
		add: seaside29 -> 'Seaside-Tests-Email-pmm.5.mcz';
		add: seaside29 -> 'Seaside-Squeak-Email-pmm.6.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:06'!
groups

	^OrderedCollection new
		addAll: self basicPackages;
		addAll: self traditionalPackages;
		add: self adminToolsPackages;
		add: self rssPackages;
		add: self javascriptPackages;
		add: self scriptaculousPackages;
		add: self htmlPackages;
		add: self internetExplorerPackages;
		add: self emailPackages;
		add: self comanchePackages;
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:29'!
htmlPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-HTML5-lr.5.mcz';
		add: seaside29 -> 'Seaside-Tests-HTML5-lr.10.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'initialize-release' stamp: 'jgf 2/6/2009 16:12'!
initialize

	super initialize.
	userName := UIManager default
		request: 'SqueakSource User Name (empty is fine)?'
		initialAnswer: ''.
	password := UIManager default
		request: 'SqueakSource Password (empty is fine)?'
		initialAnswer: ''.
	seaside29 := self seaside29.
	komHttpServer := self komHttpServer.
	doTests := UIManager default confirm: 'Run tests as packages are loaded?'.
	doTests ifTrue: [
		baseTests := TestCase suite tests.
		baseUndeclared := Undeclared keys.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/6/2009 09:29'!
internetExplorerPackages

	^OrderedCollection new
		add: seaside29 -> 'Seaside-InternetExplorer-lr.4.mcz';
		add: seaside29 -> 'Seaside-Tests-InternetExplorer-lr.6.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:06'!
javascriptPackages

	^OrderedCollection new
		add: seaside29 -> 'Javascript-Core-jf-.45.mcz';
		add: seaside29 -> 'Javascript-Squeak-Core-pmm.7.mcz';
		add: seaside29 -> 'Javascript-Tests-Core-lr.34.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'jgf 2/6/2009 09:15'!
komHttpServer

	^MCHttpRepository
		location: 'http://www.squeaksource.com/KomHttpServer'
		user: userName
		password: password.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 12:11'!
loadPackage: aString from: aRepository

	| version repositoryGroup transcript stream |
	version := aRepository loadVersionFromFileNamed: aString.
	transcript := Transcript.
	stream := WriteStream on: String new.
	[
		Transcript := stream.
		version load.
	] ensure: [
		Transcript := transcript.
	].
	self reportToTranscript: stream contents.
	repositoryGroup := version workingCopy repositoryGroup.
	repositoryGroup addRepository: aRepository.
	Transcript cr; show: 'Loaded ' , aString.
	self showUndeclared.
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 11:23'!
loadPackages: aList

	Transcript cr.
	aList do: [:assoc |
		self
			loadPackage: assoc value 
			from: assoc key.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 11:39'!
reportToTranscript: aString

	| list |
	list := aString subStrings: (Array with: $().
	list := list collect: [:each | each withBlanksTrimmed].
	list := list reject: [:each | each isEmpty].
	list := list reject: [:each | 
		16 < each size and: [ (each copyFrom: each size - 14 to: each size) = ' is Undeclared)'].
	].
	list isEmpty ifTrue: [^self].
	Transcript nextPutAll: aString.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:07'!
rssPackages

	^OrderedCollection new
		add: seaside29 -> 'RSS-Core-pmm.46.mcz';
		add: seaside29 -> 'RSS-Tests-Core-jf.19.mcz';
		add: seaside29 -> 'RSS-Examples-MAD.16.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:07'!
scriptaculousPackages

	^OrderedCollection new
		add: seaside29 -> 'Scriptaculous-Core-jf.77.mcz';
		add: seaside29 -> 'Scriptaculous-Tests-Core-pmm.25.mcz';
		add: seaside29 -> 'Scriptaculous-Components-pmm.77.mcz';
		add: seaside29 -> 'Scriptaculous-Tests-Components-obi.20.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'jgf 2/6/2009 09:09'!
seaside29

	^MCHttpRepository
		location: 'http://www.squeaksource.com/Seaside29'
		user: ''
		password: ''.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 16:12'!
showUndeclared

	| newUndeclared |
	doTests ifFalse: [^self].
	newUndeclared := Undeclared keys.
	baseUndeclared do: [:each | newUndeclared remove: each].
	newUndeclared isEmpty ifTrue: [^self].
	Transcript cr; tab; show: 'Undeclared: ' , newUndeclared asSortedCollection asArray printString.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'jgf 2/22/2009 10:17'!
traditionalPackages

	^OrderedCollection new
		"Functional Tests"	
		add: (Array 
			with: seaside29 -> 'Seaside-Tests-Functional-lr.63.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Functional-jf.10.mcz');
		"Continuation are temporarily in Basic"

		"Flow"
		add: (Array 
			with: seaside29 -> 'Seaside-Flow-jf.12.mcz'
			with: seaside29 -> 'Seaside-Squeak-Flow-jf.8.mcz'
			with: seaside29 -> 'Seaside-Tests-Flow-jf.11.mcz');
		"WebTools"
		add: (Array 
			with: seaside29 -> 'Seaside-WebTools-jf.19.mcz'
			with: seaside29 -> 'Seaside-Squeak-WebTools-jf.16.mcz'
			with: seaside29 -> 'Seaside-Tests-WebTools-lr.5.mcz');
		"Development"
		add: (Array 
			with: seaside29 -> 'Seaside-Development-jf.94.mcz'
			with: seaside29 -> 'Seaside-Squeak-Development-jf.80.mcz'
			with: seaside29 -> 'Seaside-Tests-Development-jf.26.mcz'
			with: seaside29 -> 'Seaside-Tests-Squeak-Development-jf.9.mcz');
		"Examples"
		add: (Array 
			with: seaside29 -> 'Seaside-Examples-pmm.11.mcz');
		yourself.! !
SeasideLoadOrderTests initialize!
